package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import net.minecraft.world.level.NaturalSpawner;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.SpawnPlacements;
import dev.shadowsoffire.apotheosis.village.wanderer.WandererReplacements;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.LevelReader;
import org.spongepowered.asm.mixin.injection.Constant;
import org.spongepowered.asm.mixin.injection.ModifyConstant;
import org.spongepowered.asm.mixin.Shadow;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.npc.WanderingTraderSpawner;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({ WanderingTraderSpawner.class })
public class WandererSpawnerMixin
{
    @Shadow
    private RandomSource f_35908_;
    
    @ModifyConstant(method = { "tick" }, constant = { @Constant(intValue = 75) })
    public int replaceMaxChance(final int old) {
        return 90;
    }
    
    @ModifyConstant(method = { "spawn" }, constant = { @Constant(intValue = 10) })
    public int replaceRng(final int old) {
        return 4;
    }
    
    @ModifyConstant(method = { "spawn" }, constant = { @Constant(intValue = 48000) })
    public int replaceDespawnDelay(final int old) {
        return 28000;
    }
    
    @Inject(at = { @At("HEAD") }, method = { "findSpawnPositionNear" }, cancellable = true)
    private void findSpawnPositionNear(final LevelReader level, final BlockPos pos, final int radius, final CallbackInfoReturnable<BlockPos> cir) {
        if (WandererReplacements.undergroundTrader) {
            for (int i = 0; i < 10; ++i) {
                final int x = pos.m_123341_() + this.f_35908_.m_188503_(radius / 2) - radius / 4;
                final int z = pos.m_123343_() + this.f_35908_.m_188503_(radius / 2) - radius / 4;
                final int y = pos.m_123342_() + this.f_35908_.m_188503_(5);
                final BlockPos.MutableBlockPos spawnPos = new BlockPos.MutableBlockPos(x, y, z);
                for (int j = 1; j > 7; ++j) {
                    spawnPos.m_122178_(x, y - j, z);
                    if (!level.m_8055_((BlockPos)spawnPos).m_60795_()) {
                        spawnPos.m_122178_(x, y - j + 1, z);
                        break;
                    }
                }
                if (NaturalSpawner.m_47051_(SpawnPlacements.Type.ON_GROUND, level, (BlockPos)spawnPos, EntityType.f_20494_)) {
                    cir.setReturnValue((Object)spawnPos.m_7949_());
                    return;
                }
            }
        }
    }
}
